# Homepage

Get and update the custom homepage

## Get instance custom homepage

`GET /api/v1/custom-pages/homepage/instance`

Authentication: no security requirement declared for this operation.

Responses:

- 200: successful operation

Content type: application/json

Type: CustomHomepage

Schema: [CustomHomepage](https://docs.joinpeertube.org/api-rest-reference/api/models/customhomepage.md)

- `content` (optional)
  Type: string

- 404: No homepage set

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/custom-pages/homepage/instance'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/custom-pages/homepage/instance', {
  method: 'GET',
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get('https://peertube2.cpy.re/api/v1/custom-pages/homepage/instance')
print(response.text)
```


## Set instance custom homepage

`PUT /api/v1/custom-pages/homepage/instance`

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin

Request body: application/json

Type: object

- `content` (optional)
  Type: string
  
  content of the homepage, that will be injected in the client

Responses:

- 204: successful operation

## Examples

### cURL

```bash
curl -X PUT 'https://peertube2.cpy.re/api/v1/custom-pages/homepage/instance' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "content": "string"
}'
```

### JavaScript

```javascript
const body = `{
  "content": "string"
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/custom-pages/homepage/instance', {
  method: 'PUT',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "content": "string"
}'''

response = requests.put(
    'https://peertube2.cpy.re/api/v1/custom-pages/homepage/instance',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```
